/*
 * C second pass -- tables
 */
#include "c1.h"
/*
 * Operator dope table-- see description in c0.
 */
int opdope[] {
	000000,	/* EOF */
	000000,	/* ; */
	000000,	/* { */
	000000,	/* } */
	036000,	/* [ */
	002000,	/* ] */
	036000,	/* ( */
	002000,	/* ) */
	014201,	/* : */
	007001,	/* , */
	000000,	/* field selection */
	000000,	/* reverse field selection */
	000001,	/* temporary field selection */
	000001,	/* int->ptr */
	000001,	/* ptr->int */
	000001,	/* long->ptr */
	000001,	/* field assignment */
	000001,	/* >> unsigned */
	000001,	/* =>> unsigned */
	000000,	/* 19 */
	000400,	/* name */
	000400,	/* short constant */
	000400,	/* string */
	000400,	/* float */
	000400,	/* double */
	0000400,	/* long const */
	000400,	/* long const <= 16 bits */
	000400,	/* autoi, *r++ */
	000400,	/* autod, *--r */
	000001,	/* char to pointer */
	034203,	/* ++pre */
	034203,	/* --pre */
	034203,	/* ++post */
	034203,	/* --post */
	034220,	/* !un */
	034202,	/* &un */
	034220,	/* *un */
	034200,	/* -un */
	034220,	/* ~un */
	036001,	/* . (structure reference) */
	030101,	/* + */
	030001,	/* - */
	032101,	/* * */
	032001,	/* / */
	032001,	/* % */
	026061,	/* >> */
	026061,	/* << */
	020161,	/* & */
	016161,	/* | */
	016161,	/* ^ */
	036001,	/* -> */
/* 001000,	/* int -> double */
/*	001000,	/* double -> int */
	000000,	/* int -> double */
	000000,	/* double -> int */
	000001,	/* && */
	000001,	/* || */
	030001, /* &~ */
/*	001000,	/* double -> long */
/*	001000,	/* long -> double */
	000000,	/* double -> long */
	000000,	/* long -> double */
	000000,	/* integer -> long */
	000000,	/* long -> integer */
	022005,	/* == */
	022005,	/* != */
	024005,	/* <= */
	024005,	/* < */
	024005,	/* >= */
	024005,	/* > */
	024005,	/* <p */
	024005,	/* <=p */
	024005,	/* >p */
	024005,	/* >=p */
	012213,	/* =+ */
	012213,	/* =- */
	012213,	/* =* */
	012213,	/* =/ */
	012213,	/* =% */
	012253,	/* =>> */
	012253,	/* =<< */
	012253,	/* =& */
	012253,	/* =| */
	012253,	/* =^ */
	012213,	/* = */
	030001, /* & for tests */
	032001,	/*  * (long) */
	032001,	/*  / (long) */
	032001,	/* % (long) */
	012253,	/* =& ~ */
	012213,	/* =* (long) */
	012213,	/* / (long) */
	012213,	/* % (long) */
	000001,	/* 89 */
	014201,	/* ? */
	026061,	/* long << */
	012253,	/* long =<< */
	000101,	/* max */
	000101,	/* maxp */
	000101,	/* min */
	000101,	/* minp */
	000001,	/* , */
	036001,	/* callstar */
	000000,	/* 99 */
	036001,	/* call */
	036000,	/* mcall */
	000000,	/* goto */
	000000,	/* jump cond */
	000000,	/* branch cond */
	000400,	/* set nregs */
	000000, /* 106 */
/*	001000,	/* char -> long */
/*	001000,	/* long -> char */
	000000,	/* char -> long */
	000000,	/* long -> char */
	000000,	/* int->char and char->int */
	000000,	/* force r0 */
	000000,
	000000,
	000000,
	000000,
	000000, /* structure assign  */
	000001, /* struct assign setup */
	032001,	/* unsigned divide */
	032001,	/* assign unsigned divide */
	032001,	/* unsigned modulo */
	032001,	/* assign unsigned modulo */
	000000,	/* convert char to int (fake) */
	000001, /* fstarplus */
	034220, /* fstar */
};

char	*opntab[] {
	"op 0",
	"op 1",
	"op 2",
	"op 3",
	"op 4",
	"op 5",
	"op 6",
	"op 7",
	":",
	",",
	"field select",
	"op 11",
	"op 12",
	"int->ptr",
	"ptr->int",
	"long->ptr",
	"field assign",
	">>",
	">>",
	"op 19",
	"name",
	"short constant",
	"string",
	"float",
	"double",
	"long constant",
	"long constant",
	"*r++",
	"*--r",
	"op 29",
	"++pre",
	"--pre",
	"++post",
	"--post",
	"!un",
	"&",
	"indirect",
	"-",
	"~",
	".",
	"+",
	"-",
	"*",
	"/",
	"%",
	">>",
	"<<",
	"&",
	"|",
	"^",
	"->",
	"int->double",
	"double->int",
	"&&",
	"||",
	"&~",
	"double->long",
	"long->double",
	"integer->long",
	"long->integer",
	"==",
	"!=",
	"<=",
	"<",
	">=",
	">",
	"<p",
	"<=p",
	">p",
	">=p",
	"=+",
	"=-",
	"=*",
	"=/",
	"=%",
	"=>>",
	"=<<",
	"=&",
	"=|",
	"=^",
	"=",
	"& for tests",
	"*",
	"/",
	"%",
	"=& ~",
	"=*",
	"=/",
	"=%",
	"*(x+c)",
	"?",
	"<<",
	"long =<<",
	"\\/",
	"\\/",
	"/\\",
	"/\\",
	",",
	"call *",
	"call2",
	"call",
	"op 101",
	"goto",
	"jump cond",
	"init",
	"set nregs",
	"load value",
	"char->long",
	"long->char",
	"int<->char",
	"force register",
	"",
	"",
	"",
	"",
	"= structure",
	" (struct setup)",
	"udiv",
	"=udiv",
	"umod",
	"=umod",
	"char->int"
};

/*
 * Strings for instruction tables.
 */
char	mov[]	"mov";
char	cmp[]	"cmp";
char	tst[]	"tst";
char	add[]	"add";
char	sub[]	"sub";
char	inc[]	"inc";
char	dec[]	"dec";
char	imul[]	"imul";
char	idiv[]	"idiv";
char	div[]	"div";
char	sar[]	"sar";
char	sal[]	"sal";
char	shr[]	"shr";
char	rcr[]	"rcr";
char	rcl[]	"rcl";
char	and[]	"and";
char	test[]	"test";
char	or[]	"or";
char	xor[]	"xor";
char	neg[]	"neg";
char	not[]	"not";
char	ashc[]	"ashc";
char	slmul[]	"lmul";
char	sldiv[]	"ldiv";
char	slrem[]	"lrem";
char	almul[]	"almul";
char	aldiv[]	"aldiv";
char	alrem[]	"alrem";
char	jeq[]	"beq";
char	jne[]	"bne";
char	jle[]	"ble";
char	jgt[]	"bgt";
char	jlt[]	"blt";
char	jge[]	"bge";
char	jlos[]	"blos";
char	jhi[]	"bhi";
char	jlo[]	"blo";
char	jhis[]	"bhis";
char	nop[]	"|nop";
char	jbr[]	"br";
char	goof[]	"???";

/*
 * Instruction tables, accessed by
 * I (first operand) or I' (second) macros.
 */

struct instab instab[] {
	LOAD,	mov,	goof,
	ASSIGN,	mov,	goof,
	EQUAL,	cmp,	goof,
	NEQUAL,	cmp,	goof,
	LESSEQ,	cmp,	goof,
	LESS,	cmp,	goof,
	GREATEQ,cmp,	goof,
	GREAT,	cmp,	goof,
	LESSEQP,cmp,	goof,
	LESSP,	cmp,	goof,
	GREATQP,cmp,	goof,
	GREATP,	cmp,	goof,
	PLUS,	add,	inc,
	ASPLUS,	add,	inc,
	MINUS,	sub,	dec,
	ASMINUS,sub,	dec,
	INCBEF,	add,	inc,
	DECBEF,	sub,	dec,
	INCAFT,	add,	inc,
	DECAFT,	sub,	dec,
	TIMES,	imul,	goof,
	ASTIMES,imul,	goof,
	DIVIDE,	idiv,	goof,
	ASDIV,	idiv,	goof,
	UDIV,	div,	goof,
	ASUDIV,	div,	goof,
	MOD,	idiv,	goof,
	ASMOD,	idiv,	goof,
	UMOD,	div,	goof,
	ASUMOD,	div,	goof,
	PTOI,	idiv,	goof,  /* used to be unsigned. -Hans Feb 18, 82 */
	RSHIFT,	sar,	rcr,
	ASRSH,	sar,	rcr,
	LSHIFT, sal,	rcl,
	ASLSH,	sal,	rcl,
	AND,	and,	goof,
	ASAND,	and,	goof,
	OR,	or,	goof,
	ASOR,	or,	goof,
	EXOR,	xor,	goof,
	ASXOR,	xor,	goof,
	NEG,	neg,	goof,
	COMPL,	not,	goof,
	LTIMES,	slmul,	slmul,
	LDIV,	sldiv,	sldiv,
	LMOD,	slrem,	slrem,
	LASTIMES,almul,	almul,
	LASDIV,	aldiv,	aldiv,
	LASMOD,	alrem,	alrem,
	ULSH,	shr,	rcr,
	ASULSH,	shr,	rcr,
	0,	0,	0};

/*
 * Similar table for relationals.
 * The first string is for the positive
 * test, the second for the inverted one.
 * The '200+' entries are 
 * used in tests against 0 where a 'tst'
 * instruction is used; it clears the c-bit
 * the c-bit so ptr tests are funny.
 */
struct instab branchtab[] {
	EQUAL,	jeq,	jne,
	NEQUAL,	jne,	jeq,
	LESSEQ,	jle,	jgt,
	LESS,	jlt,	jge,
	GREATEQ,jge,	jlt,
	GREAT,	jgt,	jle,
	LESSEQP,jlos,	jhi,
	LESSP,	jlo,	jhis,
	GREATQP,jhis,	jlo,
	GREATP,	jhi,	jlos,
	200+EQUAL,	jeq,	jne,
	200+NEQUAL,	jne,	jeq,
	200+LESSEQ,	jle,	jgt,
	200+LESS,	jlt,	jge,
	200+GREATEQ,	jge,	jlt,
	200+GREAT,	jgt,	jle,
	200+LESSEQP,	jeq,	jne,
	200+LESSP,	nop,	jbr,
	200+GREATQP,	jbr,	nop,
	200+GREATP,	jne,	jeq,
	0,	0,	0 };
